/**
 * @license
 * Copyright 2017 JBoss Inc
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import { ChangeDetectorRef, EventEmitter } from "@angular/core";
import { OasParameter, SimplifiedParameterType, SimplifiedType, Oas30Example, Schema } from "apicurio-data-models";
import { DropDownOption } from '../../../../../../../components/common/drop-down.component';
import { CommandService } from "../../../_services/command.service";
import { DocumentService } from "../../../_services/document.service";
import { SelectionService } from "../../../_services/selection.service";
import { AbstractRowComponent } from "../../common/item-row.abstract";
import { EditExampleEvent } from "../../dialogs/edit-example.component";
export declare class HeaderParamRowComponent extends AbstractRowComponent<OasParameter, SimplifiedParameterType> {
    private commandService;
    private _overriddenParam;
    onDelete: EventEmitter<void>;
    onRename: EventEmitter<void>;
    private _parentType;
    private overrideFlag;
    private missingFlag;
    /**
     * C'tor.
     * @param changeDetectorRef
     * @param documentService
     * @param commandService
     * @param selectionService
     */
    constructor(changeDetectorRef: ChangeDetectorRef, documentService: DocumentService, commandService: CommandService, selectionService: SelectionService);
    /**
     * Update the internal model.
     */
    protected updateModel(): void;
    isParentOperation(): boolean;
    isParentPath(): boolean;
    isParameter(): boolean;
    hasDescription(): boolean;
    is3xDocument(): boolean;
    hasExamples(): boolean;
    paramExamples(): Oas30Example[];
    exampleValue(example: Oas30Example): string;
    description(): string;
    isRequired(): boolean;
    required(): string;
    requiredOptions(): DropDownOption[];
    isEditingDescription(): boolean;
    isEditingSummary(): boolean;
    isEditingExamples(): boolean;
    toggleDescription(): void;
    toggleSummary(): void;
    toggleExamples(): void;
    delete(): void;
    displayType(): SimplifiedParameterType;
    displayExamples(): string;
    rename(): void;
    setDescription(description: string): void;
    changeRequired(newValue: string): void;
    changeType(newType: SimplifiedType): void;
    addExample(exampleData: any): void;
    deleteExample(example: Oas30Example): void;
    deleteAllExamples(): void;
    editExample(event: EditExampleEvent): void;
    schemaForExample(): Schema;
    override(): void;
    isMissing(): boolean;
    isExists(): boolean;
    isOverride(): boolean;
    isOverridable(): boolean;
    isLocalOnly(): boolean;
    getOverriddenParam(param: OasParameter): OasParameter;
    private detectParentType;
}
